with Ada.Containers.Hashed_Maps; use Ada.Containers;
with Ada.Exceptions;             use Ada.Exceptions;
with Ada.Strings.Hash;           use Ada.Strings;
with Ada.Task_Identification;    use Ada.Task_Identification;
with Ada.Task_Termination;       use Ada.Task_Termination;
with Dynamic_Tasks;              use Dynamic_Tasks;

package Dynamic_Tasks_Finalizer is

   function Task_Id_Hash (Key : Task_Id) return Hash_Type is (Hash (Image (Key)));

   package Task_Ptr_Map is new Hashed_Maps (Key_Type        => Task_Id,
                                            Element_Type    => Dynamic_Task_Ptr,
                                            Hash            => Task_Id_Hash,
                                            Equivalent_Keys => "=");

   protected Finalizer_Deallocator is

      procedure Register (Ptr : Dynamic_Task_Ptr);

   private

      procedure Last_Wish (Cause : Cause_Of_Termination;
                           Id    : Task_Id;
                           X     : Exception_Occurrence);

      Running_Tasks : Task_Ptr_Map.Map;

   end Finalizer_Deallocator;

end Dynamic_Tasks_Finalizer;
